Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.struts2.interceptor
Class FileUploadInterceptor

    java.lang.Object
      com.opensymphony.xwork2.interceptor.AbstractInterceptor
          org.apache.struts2.interceptor.FileUploadInterceptor

All Implemented Interfaces:
  Interceptor, Serializable

    public class FileUploadInterceptor

extends AbstractInterceptor

Interceptor that is based off of `MultiPartRequestWrapper`, which is automatically applied for any request that includes a file. It adds the following parameters, where [File Name] is the name given to the file uploaded by the HTML form:

- [File Name] : File - the actual File
- [File Name]ContentType : String - the content type of the file
- [File Name]FileName : String - the actual name of the file uploaded (not the HTML name)

You can get access to these files by merely providing setters in your action that correspond to any of the three patterns above, such as setDocument(File document), setDocumentContentType(String contentType), etc.
See the example code section.

This interceptor will add several field errors, assuming that the action implements `ValidationAware`. These error messages are based on several i18n values stored in struts-messages.properties, a default i18n file processed for all i18n requests. You can override the text of these messages by providing text for the following keys:

- struts.messages.error.uploading - a general error that occurs when the file could not be uploaded
- struts.messages.error.file.too.large - occurs when the uploaded file is too large
- struts.messages.error.content.type.not.allowed - occurs when the uploaded file does not match the expected content types specified

Interceptor parameters:

- maximumSize (optional) - the maximum size (in bytes) that the interceptor will allow a file reference to be set on the action. Note, this is not related to the various properties found in struts.properties. Default to approximately 2MB.
- allowedTypes (optional) - a comma separated list of content types (ie: text/html) that the interceptor will allow a file reference to be set on the action. If none is specified allow all types to be uploaded.

Extending the interceptor:

You can extend this interceptor and override the `acceptFile(java.io.File, java.lang.String, java.lang.String, com.opensymphony.xwork2.ValidationAware, java.util.Locale)` method to provide more control over which files are supported and which are not.

Example code:

     <action name="doUpload" class="com.examples.UploadAction">
         <interceptor-ref name="fileUpload"/>
         <interceptor-ref name="basicStack"/>
         <result name="success">good_result.ftl</result>
     </action>

And then you need to set encoding `multipart/form-data` in the form where the user selects the file to upload.

       <a:form action="doUpload" method="post" enctype="multipart/form-data">
           <a:file name="upload" label="File"/>
           <a:submit/>
       </a:form>

And then in your action code you'll have access to the File object if you provide setters according to the naming convention documented in the start.

        public com.examples.UploadAction implemements Action {
           private File file;
           private String contentType;
           private String filename;

           public void setUpload(File file) {
              this.file = file;
           }

           public void setUploadContentType(String contentType) {
              this.contentType = contentType;
           }

           public void setUploadFileName(String filename) {
              this.filename = filename;
           }

           ...
      }

See Also:
  Serialized Form

Field Summary
`protected String` | `allowedTypes`
`protected Set` | `allowedTypesSet`
`private static String` | `DEFAULT_DELIMITER`
`private static String` | `DEFAULT_MESSAGE`
`protected static Log` | `log`
`protected Long` | `maximumSize`
`private static long` | `serialVersionUID`

Constructor Summary
`FileUploadInterceptor()`

Method Summary
`protected boolean` | `acceptFile(File file, String contentType, String inputName, ValidationAware validation, Locale locale)` Override for added functionality.
`private static boolean` | `containsItem(Collection itemCollection, String key)`
`private static Set` | `getDelimitedValues(String delimitedString)`
`private String` | `getTextMessage(String messageKey, Object[] args, Locale locale)`
`String` | `intercept(ActionInvocation invocation)` Override to handle interception
`private static boolean` | `isNonEmpty(Object[] objArray)`
`void` | `setAllowedTypes(String allowedTypes)` Sets the allowed mimetypes
`void` | `setMaximumSize(Long maximumSize)` Sets the maximum size of an uploaded file

Methods inherited from class com.opensymphony.xwork2.interceptor.AbstractInterceptor
`destroy, init`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### serialVersionUID

    private static final long serialVersionUID

See Also:
  Constant Field Values

### log

    protected static final Log log

### DEFAULT_DELIMITER

    private static final String DEFAULT_DELIMITER

See Also:
  Constant Field Values

### DEFAULT_MESSAGE

    private static final String DEFAULT_MESSAGE

See Also:
  Constant Field Values

### maximumSize

    protected Long maximumSize

### allowedTypes

    protected String allowedTypes

### allowedTypesSet

    protected Set allowedTypesSet

Constructor Detail

### FileUploadInterceptor

    public FileUploadInterceptor()

Method Detail

### setAllowedTypes

    public void setAllowedTypes(String allowedTypes)

  Sets the allowed mimetypes

  Parameters:
    `allowedTypes` - A comma-delimited list of types

### setMaximumSize

    public void setMaximumSize(Long maximumSize)

  Sets the maximum size of an uploaded file

  Parameters:
    `maximumSize` - The maximum size in bytes

### intercept

    public String intercept(ActionInvocation invocation)
                     throws Exception

  Description copied from class: `AbstractInterceptor`
  Override to handle interception

  Specified by:
    `intercept` in interface `Interceptor`
  Specified by:
    `intercept` in class `AbstractInterceptor`
  Returns:
    the return code, either returned from `ActionInvocation.invoke()`, or from the interceptor itself.
  Throws:
    `Exception` - any system-level error, as defined in `Action.execute()`.

### acceptFile

    protected boolean acceptFile(File file,
                                 String contentType,
                                 String inputName,
                                 ValidationAware validation,
                                 Locale locale)

  Override for added functionality. Checks if the proposed file is acceptable based on contentType and size.

  Parameters:
    `file` - - proposed upload file.
    `contentType` - - contentType of the file.
    `inputName` - - inputName of the file.
    `validation` - - Non-null ValidationAware if the action implements ValidationAware, allowing for better logging.
    `locale` -
  Returns:
    true if the proposed file is acceptable by contentType and size.

### containsItem

    private static boolean containsItem(Collection itemCollection,
                                        String key)

  Parameters:
    `itemCollection` - - Collection of string items (all lowercase).
    `key` - - Key to search for.
  Returns:
    true if itemCollection contains the key, false otherwise.

### getDelimitedValues

    private static Set getDelimitedValues(String delimitedString)

### isNonEmpty

    private static boolean isNonEmpty(Object[] objArray)

### getTextMessage

    private String getTextMessage(String messageKey,
                                  Object[] args,
                                  Locale locale)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2007 Apache Software Foundation. All Rights Reserved.